<?php

namespace Drupal\monarch_vue_field\Plugin\Field\FieldWidget;

use Monarch\VueApp;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin base for vue app widgets.
 *
 * @FieldWidget(
 *   id = "vue_app_default",
 *   label = @Translation("No Vue App"),
 *   field_types = {
 *     "vue_app"
 *   },
 * )
 */
class VueAppDefaultWidget extends WidgetBase {

  const APP_NAME = 'no_app';
  const APP_NAME_ATTRIBUTE = 'data-vue-app';
  const APP_LIBRARIES = [];

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['editor'] = VueApp::create(static::APP_NAME, static::APP_LIBRARIES, static::APP_NAME_ATTRIBUTE)
      ->render($items->data ?? new \stdClass());

    $element['data'] = [
      '#type' => 'hidden',
      '#default_value' => '',
    ];

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function massageFormValues(array $values, array $form, FormStateInterface $form_state) {
    return [['data' => json_decode($values[0]['data'] ?? NULL, TRUE)]];
  }

}
